Index: applications/editors/josm/nsis/josm-setup-unix.sh
===================================================================
--- applications/editors/josm/nsis/josm-setup-unix.sh	(revision 30578)
+++ applications/editors/josm/nsis/josm-setup-unix.sh	(revision 30580)
@@ -6,9 +6,9 @@
 # apt-get install nsis
 # replace the  /usr/share/nsis/Plugins/System.dll with the Version from the nsis .zip File
-# The one comming with the debian package is missing the Call:: Function
+# The one coming with the debian package is missing the Call:: Function
 # See also /usr/share/doc/nsis/README.Debian 
 #
 # Then download launch4j from http://launch4j.sourceforge.net/ 
-# wget http://mesh.dl.sourceforge.net/sourceforge/launch4j/launch4j-3.0.0-pre2-linux.tgz
+# wget http://softlayer-ams.dl.sourceforge.net/project/launch4j/launch4j-3/3.4/launch4j-3.4-linux.tgz
 # and unpack it to /usr/share/launch4j
 
@@ -16,7 +16,7 @@
 
 # trying to find launch4j
-if [ -s /cygdrive/c/Programme/Launch4j/launch4jc.exe ]; then
-    # Windows under cygwin
-    LAUNCH4J="/cygdrive/c/Programme/Launch4j/launch4jc.exe"
+if [ -s "/cygdrive/c/Program Files (x86)/Launch4j/launch4jc.exe" ]; then
+    # Windows under cygwin or MobaXterm
+    LAUNCH4J="/cygdrive/c/Program Files (x86)/Launch4j/launch4jc.exe"
 elif [ -s /usr/share/launch4j/launch4j.jar ]; then
     # as described above
@@ -33,7 +33,7 @@
 
 # trying to find makensis
-if [ -s /cygdrive/c/Programme/nsis/makensis.exe ]; then
-    # Windows under cygwin
-    MAKENSIS="/cygdrive/c/Programme/nsis/makensis.exe"
+if [ -s "/cygdrive/c/Program Files (x86)/NSIS/makensis.exe" ]; then
+    # Windows under cygwin or MobaXterm
+    MAKENSIS="/cygdrive/c/Program Files (x86)/NSIS/makensis.exe"
 else
     # UNIX like
@@ -48,9 +48,10 @@
   export JOSM_FILE="/home/josm/www/download/josm-tested.jar"
 else
-  svncorerevision=`svnversion ../core`
-  svnpluginsrevision=`svnversion ../plugins`
-  svnrevision="$svncorerevision-$svnpluginsrevision"
+  svncorerevision=`svnversion -n ../core`
+  #svnpluginsrevision=`svnversion -n ../plugins`
+  #svnrevision="$svncorerevision-$svnpluginsrevision"
 
-  export VERSION=custom-${svnrevision}
+  #export VERSION=custom-${svnrevision}
+  export VERSION=`echo ${svncorerevision} | sed -e 's/M//g' -e 's/S//g' -e 's/P//g'`
   export JOSM_BUILD="yes"
   export WEBKIT_DOWNLOAD="yes"
@@ -58,5 +59,5 @@
 fi
 
-echo "Creating Windows Installer for josm-$VERSION"
+echo "Creating Windows Installers for josm-$VERSION"
 
 echo 
@@ -96,27 +97,45 @@
 
 /bin/cp $JOSM_FILE josm-tested.jar
-echo 
-echo "##################################################################"
-echo "### convert jar to exe with launch4j"
-# (an exe file makes attaching to file extensions a lot easier)
-# launch4j - http://launch4j.sourceforge.net/
-# delete old exe file first
-/bin/rm -f josm.exe
-$LAUNCH4J "launch4j.xml"
 
-if ! [ -s josm.exe ]; then
-    echo "NO Josm File Created"
-    exit -1
-fi
+function build_exe {
 
-echo 
-echo "##################################################################"
-echo "### create the josm-installer-${VERSION}.exe with makensis"
-# NSIS - http://nsis.sourceforge.net/Main_Page
-# apt-get install nsis
-$MAKENSIS -V2 -DVERSION=$VERSION josm.nsi
+	export TARGET=$1	# josm / josm64. Used in file name of launcher and installer
+	#export RTBITS=$2	# L4J "runtimeBits" (JVM architecture used by launcher)
+	#export INIHEAP=$3	# L4J "initialHeapSize" (initial heap size in MB)
+	#export MAXHEAP=$4	# L4J "maxHeapSize" (max heap size in MB)
+	
+	/bin/rm -f "launch4j_${TARGET}.xml"
+	/bin/sed -e "s/%TARGET%/$1/" -e "s/%RTBITS%/$2/" -e "s/%INIHEAP%/$3/" -e "s/%MAXHEAP%/$4/" -e "s/%VERSION%/$VERSION/" "launch4j.xml" > "launch4j_${TARGET}.xml"
+	
+	echo 
+	echo "##################################################################"
+	echo "### convert jar to ${TARGET}.exe with launch4j"
+	# (an exe file makes attaching to file extensions a lot easier)
+	# launch4j - http://launch4j.sourceforge.net/
+	# delete old exe file first
+	/bin/rm -f ${TARGET}.exe
+	"$LAUNCH4J" "launch4j_${TARGET}.xml"
 
-# keep the intermediate file, for debugging
-/bin/rm josm-intermediate.exe 2>/dev/null >/dev/null
+	if ! [ -s ${TARGET}.exe ]; then
+		echo "NO ${TARGET}.exe File Created"
+		exit -1
+	fi
+
+	/bin/rm -f "launch4j_${TARGET}.xml"
+
+	echo 
+	echo "##################################################################"
+	echo "### create the ${TARGET}-installer-${VERSION}.exe with makensis"
+	# NSIS - http://nsis.sourceforge.net/Main_Page
+	# apt-get install nsis
+	"$MAKENSIS" -V2 -DVERSION=$VERSION -DDEST=$TARGET josm.nsi
+
+	# keep the intermediate file, for debugging
+	/bin/rm -f ${TARGET}-intermediate.exe 2>/dev/null >/dev/null
+	/bin/mv ${TARGET}.exe ${TARGET}-intermediate.exe 2>/dev/null >/dev/null
+}
+
+build_exe "josm" "64\/32" 128 1024
+build_exe "josm64"  "64" 256 2048
+
 /bin/rm -f josm-tested.jar 2>/dev/null >/dev/null
-/bin/mv josm.exe josm-intermediate.exe 2>/dev/null >/dev/null
Index: applications/editors/josm/nsis/josm.nsi
===================================================================
--- applications/editors/josm/nsis/josm.nsi	(revision 30578)
+++ applications/editors/josm/nsis/josm.nsi	(revision 30580)
@@ -6,6 +6,4 @@
 ; If you get an error here, please update to at least NSIS 2.07!
 SetCompressor /SOLID lzma
-
-!define DEST "josm"
 
 ; Used to refresh the display of file association
@@ -47,5 +45,5 @@
 !define MUI_WELCOMEPAGE_TEXT $(JOSM_WELCOME_TEXT) 
 
-!define MUI_FINISHPAGE_RUN "$INSTDIR\josm.exe"
+!define MUI_FINISHPAGE_RUN "$INSTDIR\${DEST}.exe"
 
 
@@ -267,8 +265,8 @@
 WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "DisplayName" "JOSM ${VERSION}"
 WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "UninstallString" '"$INSTDIR\uninstall.exe"'
-WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "Publisher" "The OpenStreetMap developer community, http://www.openstreetmap.org/"
-WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "HelpLink" "mailto:newbies@openstreetmap.org."
-WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "URLInfoAbout" "http://www.openstreetmap.org/"
-WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "URLUpdateInfo" "http://wiki.openstreetmap.org/index.php/JOSM"
+WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "Publisher" "The OpenStreetMap JOSM developers team, https://josm.openstreetmap.de"
+WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "HelpLink" "mailto:josm-dev@openstreetmap.org."
+WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "URLInfoAbout" "https://josm.openstreetmap.de"
+WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "URLUpdateInfo" "https://josm.openstreetmap.de"
 WriteRegDWORD HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "NoModify" 1
 WriteRegDWORD HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM" "NoRepair" 1
@@ -276,6 +274,6 @@
 
 ; Write an entry for ShellExecute
-WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\App Paths\josm.exe" "" '$INSTDIR\josm.exe'
-WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\App Paths\josm.exe" "Path" '$INSTDIR'
+WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\App Paths\${DEST}.exe" "" '$INSTDIR\${DEST}.exe'
+WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\App Paths\${DEST}.exe" "Path" '$INSTDIR'
 
 SectionEnd ; "Required"
@@ -286,5 +284,5 @@
 SectionIn 1
 SetOutPath $INSTDIR
-File "josm.exe"
+File "${DEST}.exe"
 File "josm-tested.jar"
 
@@ -328,5 +326,5 @@
 ; To quote "http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dnwue/html/ch11d.asp":
 ; "Do not include Readme, Help, or Uninstall entries on the Programs menu."
-CreateShortCut "$SMPROGRAMS\JOSM.lnk" "$INSTDIR\josm.exe" "" "$INSTDIR\josm.exe" 0 "" "" $(JOSM_LINK_TEXT)
+CreateShortCut "$SMPROGRAMS\JOSM.lnk" "$INSTDIR\${DEST}.exe" "" "$INSTDIR\${DEST}.exe" 0 "" "" $(JOSM_LINK_TEXT)
 SectionEnd
 
@@ -335,5 +333,5 @@
 ; Create desktop icon
 ; Desktop icon for a program should not be installed as default!
-CreateShortCut "$DESKTOP\JOSM.lnk" "$INSTDIR\josm.exe" "" "$INSTDIR\josm.exe" 0 "" "" $(JOSM_LINK_TEXT)
+CreateShortCut "$DESKTOP\JOSM.lnk" "$INSTDIR\${DEST}.exe" "" "$INSTDIR\${DEST}.exe" 0 "" "" $(JOSM_LINK_TEXT)
 SectionEnd
 
@@ -342,5 +340,5 @@
 ; Create quick launch icon. Does not really exist as of Windows 7/8 but still advanced users use it.
 ; Only disable it by default, see #10241
-CreateShortCut "$QUICKLAUNCH\JOSM.lnk" "$INSTDIR\josm.exe" "" "$INSTDIR\josm.exe" 0 "" "" $(JOSM_LINK_TEXT)
+CreateShortCut "$QUICKLAUNCH\JOSM.lnk" "$INSTDIR\${DEST}.exe" "" "$INSTDIR\${DEST}.exe" 0 "" "" $(JOSM_LINK_TEXT)
 SectionEnd
 
@@ -350,6 +348,6 @@
 ; Create File Extensions
 WriteRegStr HKCR ${OSM_ASSOC} "" "OpenStreetMap data"
-WriteRegStr HKCR "${OSM_ASSOC}\Shell\open\command" "" '"$INSTDIR\josm.exe" "%1"'
-WriteRegStr HKCR "${OSM_ASSOC}\DefaultIcon" "" '"$INSTDIR\josm.exe",0'
+WriteRegStr HKCR "${OSM_ASSOC}\Shell\open\command" "" '"$INSTDIR\${DEST}.exe" "%1"'
+WriteRegStr HKCR "${OSM_ASSOC}\DefaultIcon" "" '"$INSTDIR\${DEST}.exe",0'
 push $R0
 	StrCpy $R0 ".osm"
@@ -394,5 +392,5 @@
 	Abort $(un.JOSM_IN_USE_ERROR)
 NoJOSMErrorMsg:
-Delete "$INSTDIR\josm.exe"
+Delete "$INSTDIR\${DEST}.exe"
 Delete "$INSTDIR\imageformats\qjpeg4.dll"
 RMDir "$INSTDIR\imageformats"
@@ -406,6 +404,6 @@
 
 DeleteRegKey HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\OSM"
-DeleteRegKey HKEY_LOCAL_MACHINE "Software\josm.exe"
-DeleteRegKey HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\App Paths\josm.exe"
+DeleteRegKey HKEY_LOCAL_MACHINE "Software\${DEST}.exe"
+DeleteRegKey HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\App Paths\${DEST}.exe"
 
 ; Remove Language preference info
Index: applications/editors/josm/nsis/launch4j.xml
===================================================================
--- applications/editors/josm/nsis/launch4j.xml	(revision 30578)
+++ applications/editors/josm/nsis/launch4j.xml	(revision 30580)
@@ -1,14 +1,13 @@
 <launch4jConfig>
+  <headerType>gui</headerType>
+  <outfile>%TARGET%.exe</outfile>
+  <jar>josm-tested.jar</jar>
   <dontWrapJar>true</dontWrapJar>
-  <headerType>0</headerType>
-  <jar>josm-tested.jar</jar>
-  <outfile>josm.exe</outfile>
   <errTitle></errTitle>
+  <downloadUrl>https://java.com/download</downloadUrl>
+  <supportUrl></supportUrl>
   <cmdLine></cmdLine>
   <chdir></chdir>
   <priority>normal</priority>
-  <downloadUrl>https://java.com/download</downloadUrl>
-  <supportUrl></supportUrl>
-  <customProcName>false</customProcName>
   <stayAlive>true</stayAlive>
   <icon>logo.ico</icon>
@@ -17,7 +16,20 @@
     <minVersion>1.7.0</minVersion>
     <maxVersion></maxVersion>
-    <dontUsePrivateJres>false</dontUsePrivateJres>
-    <initialHeapSize>128</initialHeapSize>
-    <maxHeapSize>1024</maxHeapSize>
+    <jdkPreference>preferJre</jdkPreference>
+	<runtimeBits>%RTBITS%</runtimeBits>
+    <initialHeapSize>%INIHEAP%</initialHeapSize>
+    <maxHeapSize>%MAXHEAP%</maxHeapSize>
   </jre>
+  <versionInfo>
+    <fileVersion>1.5.0.%VERSION%</fileVersion>
+    <txtFileVersion>%VERSION%</txtFileVersion>
+    <fileDescription>Java OpenStreetMap Editor</fileDescription>
+    <copyright>GNU General Public License v2 or later</copyright>
+    <productVersion>1.5.0.%VERSION%</productVersion>
+    <txtProductVersion>%VERSION%</txtProductVersion>
+    <productName>JOSM</productName>
+    <companyName>OpenStreetMap</companyName>
+    <internalName>%TARGET%</internalName>
+    <originalFilename>%TARGET%.exe</originalFilename>
+  </versionInfo>
 </launch4jConfig>
